var height = 0;
var width = 0;

var showingback = false;

// debugging hacks

function _in(name) {
    // alert("In: " + name);
}

function _out(name, result) {
    // alert("Out:" + name);
    return result;
}


// Resize the widget window to the given dimensions.

function resize(w, h) {
    if (showingback) {
        return;
    }
    if (!w && !h) {
        // Go to the good default size for our icon.
        w = 153;
        h = 155;
    }

    if (!w || w < 50) w = 50;
    if (!h || h < 50) h = 50;

    document.getElementById("picture").width = w;
    document.getElementById("picture").height = h;

    width = w;
    height = h;

    setPref("width", width);
    setPref("height", height);

    window.resizeTo(width, height);
}


function relayout() {
    var w = width;
    var h = height;
    resize(w+1, h+1);
    resize(w, h);
}

var lastidentifier = '';

var keysused = {};

function makeKey(key) {
//     if (!widget || !widget.identifier ) {
//         alert("No widget.identifier");
//     }
//     if (widget.identifier != lastidentifier) {
//         alert("widget.identifier is now " + widget.identifier);
//         lastidentifier = widget.identifier;
//     }
    keysused[key] = 1;
    return widget.identifier + "-" + key;
}

function getPref(key) {
    return widget.preferenceForKey(makeKey(key));
}

function setPref(key, value) {
    //alert("calling setPref with (" + key + "," + value + ")");
    widget.setPreferenceForKey(value, makeKey(key));
}



function setup()
{
    _in("setup");

    // alert("setup: setting up for " + widget.identifier);

    if (!getPref("hiddensecs")) {
        setPref("hiddensecs", 300);
    }
    if (!getPref("visiblesecs")) {
        setPref("visiblesecs", 60);
    }

    if (getPref("dospinner") == undefined) {
        setPref("dospinner", true);
    }

    width = getPref("width");
    height = getPref("height");
    relayout();

    showLoading();

    var picturesrc = getPref("image");
    if(picturesrc && picturesrc.length>0) {
        document.getElementById('urlInput').value = picturesrc;
        updateImage();
    } else {
        showPrefs();
    }
    _out("setup");
}


function nowKnowSize() {
    if (getPref("sizeToFit")) {
        var hiddenPic = document.getElementById("hiddenPic");
        resize(hiddenPic.width, hiddenPic.height);
    }
}


function resetTimer() {
    if (updateTimer != null) {
        clearInterval(updateTimer);
    }
    delay = getPref(hidden ? "hiddensecs" : "visiblesecs")  * 1000;
    if (delay < 1000) {
        delay = 1000;
    }
    updateTimer = setTimeout('updateImage();', delay);
}

function imageLoaded() {
    _in("imageLoaded");
    document.getElementById("spinner").style.display = "none";
    resetTimer();
    if (getPref("sizeToFit")) {
        var hiddenPic = document.getElementById("hiddenPic");
        hiddenPic.onload = nowKnowSize;
        hiddenPic.src = document.getElementById("picture").src;
    }
    _out("imageLoaded");
}



function showLoading() {
    document.getElementById("picture").src = "Images/loading.png";
}


var uniqueNum = 0;
var updateTimer = null;
var hidden = false;

function updateImage() {
    _in("updateImage");
    var uri = getPref("image");
    uniqueNum++;
    if (!uri || uri == '') {
        // uri = "Default.png";
        uri = "deliberatelyBustedImage.png";
        //        if (!showingback) {
        //            showPrefs();
        //        }
    } else {
        if (uri.match(/\?/)) {
            uri += "&__geekimage_num=" + uniqueNum;
        } else {
            uri += "?__geekimage_num=" + uniqueNum;
        }
    }

    // alert("Updating image to " + uri);
    var picture = document.getElementById("picture");
    picture.onload = imageLoaded;
    picture.src = uri;
    // alert("did update part");
        
    if (getPref("dospinner")) {
        document.getElementById("spinner").style.display = "block";
    }
    resetTimer();
    _out("updateImage");
}


function onhide() {
    _in("onhide");
    hidden = true;
    _out("onhide");
}

function onshow() {
    _in("onshow");
    hidden = false;
    updateImage();

    refigureGrowBoxVisibility();

    _out("onshow");
}

function refigureGrowBoxVisibility() {
    var growbox = document.getElementById("growbox");
    var parent = document.getElementById("front");
    if (getPref("sizeToFit")) {
        if (growbox) {
            parent.removeChild(growbox);
        }
    } else {
        if (!growbox) {
            growbox = document.createElement("img");
            growbox.setAttribute("id", "growbox");
            growbox.src = "/System/Library/WidgetResources/resize.png";
            growbox.addEventListener("mousedown", growMouseDown, true);
            parent.appendChild(growbox);
        }
    }
}


function showPrefs() {
    _in("showPrefs");
    showingback = true;
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    
    window.resizeTo(400, 400);

    widget.prepareForTransition("ToBack");
    

    front.style.display="none";
    back.style.display="block";
                

    setTimeout('widget.performTransition();', 0);


    var sizeToFitOn  = document.getElementById("sizeToFitOn");
    var sizeToFitOff = document.getElementById("sizeToFitOff");
    if (getPref("sizeToFit")) {
        sizeToFitOn.checked = true;
        sizeToFitOff.checked = false;
    } else {
        sizeToFitOn.checked = false;
        sizeToFitOff.checked = true;
    }

    document.getElementById("hiddensecs").value = getPref("hiddensecs");
    document.getElementById("visiblesecs").value = getPref("visiblesecs");
        
    document.getElementById("dospinner").checked = getPref("dospinner");

    document.getElementById("prefButtonHighlight").style.display='none';
    _out("showPrefs");
}


function saveNumericPref(name) {
    var value = parseInt(document.getElementById(name).value);
    if (value && value > 0) {
        setPref(name, value);
    }
}

function hidePrefs()
{
    _in("hidePrefs");
    
    showingback = false;
    resize(width, height);
    
    document.getElementById("doneButton").src = "Images/done.png";

    var newimage = document.getElementById('urlInput').value;
    var newSizeToFit = document.getElementById('sizeToFitOn').checked;
    if (newimage != getPref("image") ||
        (newSizeToFit && !getPref("sizeToFit")))
    {
        showLoading();
    }

    setPref("image", newimage);
    setPref("sizeToFit", newSizeToFit);

    setPref("dospinner", document.getElementById("dospinner").checked);


    var front = document.getElementById("front");
    var back = document.getElementById("back");
    
    widget.prepareForTransition("ToFront");

    front.style.display="block";
    back.style.display="none";
    

    refigureGrowBoxVisibility();

    saveNumericPref("hiddensecs");
    saveNumericPref("visiblesecs");

    relayout();

    setTimeout ('widget.performTransition();', 0);
    _out("hidePrefs");
}



// Preferences button animation
// These functions are used to animate the appearance and disappearance of the the preferences 
// button on the front side of the widget.

var flipShown = false;

// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property.
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
        
    // alert("Calling animate");
    
    T = limit_3(time-animation.starttime, 0, animation.duration);
    
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
    // alert("animate: Setting opacity to " + animation.now);
    animation.firstElement.style.opacity = animation.now;
}

// mousemove() is triggered whenever a mouse is moved within the bounds of your widget.  It's used
// here to prep the preference flipper fade when the mouse first enters the widget boundries.
function mousemove (event)
{
    // alert("mousemove called");
    if (!flipShown)
    {
        // fade in the flip widget
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        
        var starttime = (new Date).getTime() - 13; // set it back one frame
        
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('prefButton');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the flip widget
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
        
        var starttime = (new Date).getTime() - 13; // set it back one frame
        
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('prefButton');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}


/**************************/
// General live-resize code
// This code shows how to implement live-resizing in a widget
/**************************/

var lastPos;        // tracks where the last mouse position was throughout the drag

// The mouseDown function is called the user clicks on the growbox.  It prepares the
// widget to be resized and registers handlers for the resizing operations
function growMouseDown(event)
{
    _in("growMouseDown");

    if (getPref("sizeToFit")) {
        _out("growMouseDown");
        return;
    }

    var x = event.x + window.screenX;       // the placement of the click
    var y = event.y + window.screenY;
    
    document.addEventListener("mousemove", growMouseMove, true);    // begin tracking the move
    document.addEventListener("mouseup", growMouseUp, true);        // and notify when the drag ends

    lastPos = {x:x, y:y};       // track where the initial mouse down was, for later comparisons
                                // the mouseMove function

    event.stopPropagation();
    event.preventDefault();
    _out("growMouseDown");
}


// mouseMove performs the actual resizing of the widget.  It is called after mouseDown
// activates it and every time the mouse moves.
function growMouseMove(event)
{
    _in("growMouseMove");
    
    var screenX = event.x + window.screenX;     // retrieves the current mouse position
    var screenY = event.y + window.screenY;
        
    var deltaX = 0;     // will hold the change since the last mouseMove event
    var deltaY = 0;

    if ( (window.outerWidth + (screenX - lastPos.x)) >= 60 ) {      // sets a minimum width constraint
        deltaX = screenX - lastPos.x;                               // if we're greater than the constraint,
        lastPos.x = screenX;                                        // save the change and update our past position
    }

    if ( (window.outerHeight + (screenY - lastPos.y)) >= 25 ) {     // setting contrains for the heght
        deltaY = screenY - lastPos.y;
        lastPos.y = screenY;
    }
    
    resize(window.outerWidth + deltaX, window.outerHeight + deltaY);

    event.stopPropagation();
    event.preventDefault();
    _out("growMouseMove");
}


// mouseUp is called when the user stops resizing the widget.  It removes the mouseMove and
// mouseUp event handlers, so that the widget doesn't continute resizing (because the mouse
// button is now up
function growMouseUp(event)
{
    _in("growMouseUp");
    document.removeEventListener("mousemove", growMouseMove, true);
    document.removeEventListener("mouseup", growMouseUp, true); 

    event.stopPropagation();
    event.preventDefault();
    _out("growMouseUp");
}



function onremove()
{
    _in("onremove");
    for (var i in keysused) {
        // Don't do this for now.  I have seen some evidence that onremove()
        // is getting called inappropriately, causing settings to be lost.
        // setPref(i, null);
    }
    _out("onremove");
}


widget.onhide = onhide;
widget.onshow = onshow;
widget.onremove = onremove;
